; ##############################################################################
; ##############################################################################
; ##############################################################################
TV_PIN_INITIALISIERUNG:
	; auf AUSGANG								
	sbi (TV_SYNC_DDR),(TV_SYNC_PIN_NR)		; SYNC	
	sbi (TV_DATA_DDR),(TV_DATA_PIN_NR)		; DATA	
	; auf HIGH								
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC	
	sbi (TV_DATA_PORT),(TV_DATA_PIN_NR)		; DATA	
	; auf LOW								
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC	
	cbi (TV_DATA_PORT),(TV_DATA_PIN_NR)		; DATA	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; den ersten auftretenden FEHLER speichern										
TV_ERROR_SPEICHERN_TEMP:
	push temp1
	LDS temp1,(adr_ERROR_CODE_TV)
	tst temp1
	breq TV_ERROR_SPEICHERN_TEMP_RUN
	pop temp1
	ret
TV_ERROR_SPEICHERN_TEMP_RUN:
	STS(adr_ERROR_CODE_TV),temp
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR	; ROT  an	
	pop temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; TIMER0 8-BIT-TIMER															
;																				
; CS02 CS01 CS00																
;	0 	0	0 	No clock source (Timer/Counter stopped)							
;	0 	0 	1 	clkI/O/(No prescaling)											
; *	0 	1 	0 	clkI/O/8 (From prescaler)										
;	0 	1 	1 	clkI/O/64 (From prescaler)										
;	1 	0 	0 	clkI/O/256 (From prescaler)										
;	1 	0 	1 	clkI/O/1024 (From prescaler)									
;	1 	1 	0 	External clock source on T0 pin. Clock on falling edge.			
;	1 	1 	1 	External clock source on T0 pin. Clock on rising edge.			
;																				
; Mode WGM2 WGM1 WGM0 	Mode 													
; 	0 	0 	0 	 0 		Normal 													
; 	1 	0 	0 	 1 		PWM														
; *	2 	0 	1 	 0 		CTC														
; 	3 	0 	1 	 1 		Fast													
; 	5 	1 	0 	 1 		PWM														
; 	7 	1 	1 	 1 		Fast PWM												
;																				
; 64s TIMER																	
TIMER0_INITIALISIERUNG_CTC:
	; TCCR0A  Timer/Counter Control Register A		
	ldi temp, (0<<COM0A1)| (1<<COM0A0)|(0<<COM0B1)|(0<<COM0B0)|(1<<WGM01)|(0<<WGM00)
	OUT TCCR0A,temp
	; TCCR0B  Timer/Counter Control Register B		
	ldi temp, (0<<FOC0A)| (0<<FOC0B)|(0<<WGM02)|(0<<CS02)|(1<<CS01)|(0<<CS00)
	OUT TCCR0B,temp
	; TIMSK0  Timer/Counter Interrupt Mask Register
	ldi temp, (0<<OCIE0B)| (1<<OCIE0A)|(0<<TOIE0)
	STS TIMSK0,temp
	; OCR0A  Output Compare Register A				
	ldi temp,(TIMER0_CTC)
	OUT OCR0A,temp
	; STARTWERT										
	OUT TCNT0,NULL
	; auf AUSGANG (15625/2=7.812,5 Hz)									
	sbi DDRB,PB3	; PIN OC0A
;	sbi DDRB,PB4	; PIN OC0B
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; TIMER2 8-BIT-TIMER															
;																				
; CS22 CS21 CS20																
;	0 	0 	0 	No clock source (Timer/Counter stopped).						
;*	0 	0 	1 	clkT2S/(No prescaling)											
;	0 	1 	0 	clkT2S/8 (From prescaler)										
;	0 	1 	1 	clkT2S/32 (From prescaler)										
;	1 	0 	0 	clkT2S/64 (From prescaler)										
;	1 	0 	1 	clkT2S/128 (From prescaler)										
;	1 	1 	0 	clkT2S/256 (From prescaler)										
;	1 	1 	1 	clkT2S/1024 (From prescaler)									
;																				
; Fr TAKTKORREKTUR beim INTERRUPTAUFRUF										
TIMER2_INITIALISIERUNG:
	; TCCR2B  Timer/Counter Control Register B		
	ldi temp, (0<<FOC2A)| (0<<FOC2B)|(0<<CS22)|(0<<CS21)|(1<<CS20)
	STS TCCR2B,temp
	; TIMSK2  Timer/Counter Interrupt Mask Register
	ldi temp, (0<<OCIE2B)| (0<<OCIE2A)|(0<<TOIE2)
	STS TIMSK2,temp
	; STARTWERT										
	STS TCNT2,NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 64s ms  TIMER																
; Alle 64 s muss eine TV-Zeile geschrieben werden								
;																				
TIM0_COMPA:
	in	SREG_KOPIE ,SREG		
	mov TEMP_KOPIE ,temp	
	mov TEMP1_KOPIE,temp1
	mov TEMP2_KOPIE,temp2
	MOVW ZL_KOPIE,ZL		; Copy Register Word
;-------------------------------------------------------------------------------
; TAKTKORREKTUR beim INTERRUPTAUFRUF, sonst jittert das TV-BILD					
	LDS temp,TCNT2		; Kontrolltimer auslesen	
	cpi temp,(11+1)		; im Bereich ?				
	brlo TAKTKOREKTUR_RUN
	STS(adr_ERROR_WERT_TV),temp
	; ERROR				
	LDS temp,TCNT2		; Kontrolltimer KORREKTUR	
	SUBI TEMP,-8		; +5
	STS TCNT2,temp
	ldi temp,(ERROR_CODE_TV_A)
	rcall TV_ERROR_SPEICHERN_TEMP	; ERROR speichern
	clr temp			; NULL						
;-------------------------------------------------------------------------------
TAKTKOREKTUR_RUN:
	ldi ZL, LOW(TAKTKOREKTUR_SPRUNGMARKE)
	ldi ZH,HIGH(TAKTKOREKTUR_SPRUNGMARKE)
	add ZL,temp
	adc ZH,NULL
	IJMP		; SPRUNG (Zeiger nach Z)
TAKTKOREKTUR_SPRUNGMARKE:
	nop	; 0
	nop	; 1
	nop	; 2
	nop	; 3
	nop	; 4
	nop	; 5
	nop	; 6
	nop	; 7
	nop	; 8
	nop	; 9
	nop	; 10
	nop	; 11
;-------------------------------------------------------------------------------
; Hier legen wir fest, wie jede einzelne Zeile (1..625) 						
; beschaffen ist, sieht zwar etwas seltsam aus, 								
; aber dafr werden immer die gleiche Anzahl von Takten bentigt und 			
; man erspart sich eine Menge Rechner- und Ausgleicherei.						
;																				
; Ein TV Bild besteht aus 625 Zeilen (BRUTTO).									
; Das erste Halbbild:         1...312,5 = 312,5 ZEILEN							
; Das zweite Halbbild:    312,5...625   = 312,5 ZEILEN							
;																				
; Nutzbare Zeilen:   	   23,5...310 	 = 287,5 ZEILEN							
;				     	    336...623,5 = 288,5	 ZEILEN							
;  																				
; TV-BILD: 320x256=81.920 PIXEL ---> :8=10.240 BYTE SRAM						
;																				
	;**********	 BILD erzeugen	**********	
	; ZEILENNUMMER +1						
	add TV_ZEILE_NR_L,EINS
	adc TV_ZEILE_NR_H,NULL
	; Z-ZEIGER initialisieren				
	mov ZL,TV_ZEILE_NR_L
	mov ZH,TV_ZEILE_NR_H
	ldi temp, LOW (BILDAUFBAU_SPRUNGMARKE)
	ldi temp1,HIGH(BILDAUFBAU_SPRUNGMARKE)
	add ZL,temp
	adc ZH,temp1
	IJMP		; SPRUNG (Zeiger nach Z)	
;-------------------------------------------------------------------------------
BILDAUFBAU_SPRUNGMARKE:
	; 1. Halbbild																
	rjmp ZEILE_HAUPTIMPULSE_INITIALISIERUNG ;1 (HAUPTIMPULSE+INITIALISIERUNG)	
	rjmp ZEILE_HAUPTIMPULSE					;2 (HAUPTIMPULSE)				
	rjmp ZEILE_HAUPTIMPULS_NACHTRABANT_Z3	;3 (HAUPTIMPULS/NACHTRABANT)	
	rjmp ZEILE_TRABANTEN					;4 (TRABANTEN)					
	rjmp ZEILE_TRABANTEN					;5 (TRABANTEN)					
	MACRO_TV_ZEILE_NULL_10					;6 (Zeilen ohne INHALT)			
	MACRO_TV_ZEILE_NULL_10 					;16
	MACRO_TV_ZEILE_NULL_10					;26
	MACRO_TV_ZEILE_NULL_1 					;36
	MACRO_TV_ZEILE_NULL_1 					;37
	MACRO_TV_ZEILE_NULL_1 					;38
	MACRO_TV_ZEILE_NULL_1 					;39
	MACRO_TV_ZEILE_NULL_1 					;40
	MACRO_TV_ZEILE_NULL_1 					;41
	MACRO_TV_ZEILE_NULL_1 					;42
	rjmp ZEILE_NULL_UND_DATA_INITIALISIERUNG;43
	MACRO_TV_ZEILE_DATA_256					;44 (256 DATA-ZEILEN)		
	MACRO_TV_ZEILE_NULL_10					;300
	MACRO_TV_ZEILE_NULL_1 					;310
	rjmp ZEILE_TRABANTEN					;311 (TRABANTEN)					
	rjmp ZEILE_TRABANTEN					;312 (TRABANTEN)					
	; 2. Halbbild																
	rjmp ZEILE_TRABANT_HAUPTIMPULS_Z313		;313 (TRABANT/HAUPTIMPULS)	
	rjmp ZEILE_HAUPTIMPULSE					;314 (HAUPTIMPULSE)			
	rjmp ZEILE_HAUPTIMPULSE					;315 (HAUPTIMPULSE)			
	rjmp ZEILE_TRABANTEN					;316 (TRABANTEN)			
	rjmp ZEILE_TRABANTEN					;317 (TRABANTEN)			
	MACRO_TV_ZEILE_NULL_10					;318
	MACRO_TV_ZEILE_NULL_10 					;328
	MACRO_TV_ZEILE_NULL_10					;338
	MACRO_TV_ZEILE_NULL_1 					;348
	MACRO_TV_ZEILE_NULL_1 					;349
	MACRO_TV_ZEILE_NULL_1 					;350
	MACRO_TV_ZEILE_NULL_1 					;351
	MACRO_TV_ZEILE_NULL_1 					;352
	MACRO_TV_ZEILE_NULL_1 					;353
	MACRO_TV_ZEILE_NULL_1 					;354
	MACRO_TV_ZEILE_NULL_1 					;355
	rjmp ZEILE_NULL_UND_DATA_INITIALISIERUNG;356
	MACRO_TV_ZEILE_DATA_256					;357 (256 DATA-ZEILEN)		
	MACRO_TV_ZEILE_NULL_10					;613
	rjmp ZEILE_SYNCHRONIMPULS_TRABANT_Z623	;623 (SYNC+TRABANT)			
	rjmp ZEILE_TRABANTEN					;624 (TRABANTEN)			
	rjmp ZEILE_TRABANTEN					;625 (TRABANTEN)			
	rjmp ZEILE_HAUPTIMPULSE_INITIALISIERUNG ;1 (HAUPTIMPULSE+INITIALISIERUNG)	
BILDAUFBAU_FERTIG:
;-------------------------------------------------------------------------------
	OUT	SREG ,SREG_KOPIE		
	mov TEMP ,temp_KOPIE
	mov TEMP1,temp1_KOPIE	    			
	mov TEMP2,temp2_KOPIE	    			
	MOVW ZL,ZL_KOPIE 	; Copy Register Word
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
; HAUPTIMPULSE																	
; und ZEILENNUMMER-INITIALISIERUNG												
ZEILE_HAUPTIMPULSE_INITIALISIERUNG:
	; HAUPTIMPULS							
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L	/ 0 Volt   / 27,3s		
	rcall WAIT_27_3us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt / 4,7s		
	rcall WAIT_4_7us
	; HAUPTIMPULS							
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L	/ 0 Volt   / 27,3s		
	rcall WAIT_27_3us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt 				
	; ZEILENNUMMER RESET					
	clr TV_ZEILE_NR_L
	clr TV_ZEILE_NR_H
rjmp BILDAUFBAU_FERTIG
; ##############################################################################
; ##############################################################################
; ##############################################################################
; HAUPTIMPULSE																	
ZEILE_HAUPTIMPULSE:
	; HAUPTIMPULS							
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L	/ 0 Volt   / 27,3s		
	rcall WAIT_27_3us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt / 4,7s		
	rcall WAIT_4_7us
	; HAUPTIMPULS							
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L	/ 0 Volt   / 27,3s		
	rcall WAIT_27_3us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt 				
rjmp BILDAUFBAU_FERTIG
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ZEILE-3																		
; HAUPTIMPULS / TRABANT															
ZEILE_HAUPTIMPULS_NACHTRABANT_Z3:
	; HAUPTIMPULS							
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L	/ 0 Volt   / 27,3s		
	rcall WAIT_27_3us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt / 4,7s		
	rcall WAIT_4_7us
	; TRABANT								
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L	/ 0 Volt / 2,35s		
	rcall WAIT_2_35us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt 				
rjmp BILDAUFBAU_FERTIG
; ##############################################################################
; ##############################################################################
; ##############################################################################
; TRABANTEN																		
ZEILE_TRABANTEN:
	; TRABANT								
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L	/ 0 Volt   / 2,35s		
	rcall WAIT_2_35us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt / 29,65s	
	rcall WAIT_29_65us
	; TRABANT								
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L	/   0 Volt / 2,35s		
	rcall WAIT_2_35us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt 				
rjmp BILDAUFBAU_FERTIG
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ZEILE-313																		
; TRABANT + HAUPTIMPULS															
ZEILE_TRABANT_HAUPTIMPULS_Z313:
	; TRABANT								
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L	/ 0 Volt   / 2,35s		
	rcall WAIT_2_35us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt / 29,65s	
	rcall WAIT_29_65us
	; HAUPTIMPULS							
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L	/ 0 Volt  /  29,65s	
	rcall WAIT_29_65us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt 				

;-------------------------------------------------------------------------------
	; ZEILEN-NR-CHECK		
	mov ZL,TV_ZEILE_NR_L
	mov ZH,TV_ZEILE_NR_H
	cpi ZH,HIGH(313-1)
	brne ZEILE_TRABANT_HAUPTIMPULS_Z313_ERROR
	cpi ZL,LOW (313-1)
	brne ZEILE_TRABANT_HAUPTIMPULS_Z313_ERROR
rjmp BILDAUFBAU_FERTIG
;-------------------------------------------------------------------------------
ZEILE_TRABANT_HAUPTIMPULS_Z313_ERROR:
	;ERROR
	ldi temp,(ERROR_CODE_TV_C)
	rcall TV_ERROR_SPEICHERN_TEMP	; ERROR speichern
rjmp BILDAUFBAU_FERTIG
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ZEILE-623																		
; SYNCHRONIMPULS + TRABANT														
ZEILE_SYNCHRONIMPULS_TRABANT_Z623:
	; SYNCHRONIMPULS						
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L	/ 0 Volt   / 4,7s		
	rcall WAIT_4_7us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	; 0,3 Volt 				
	; TRABANT								
	rcall WAIT_29_65us
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L	/ 0 Volt   / 2,35s		
	rcall WAIT_2_35us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	/ 0,3 Volt 				
;-------------------------------------------------------------------------------
	; ZEILEN-NR-CHECK		
	mov ZL,TV_ZEILE_NR_L
	mov ZH,TV_ZEILE_NR_H
	cpi ZH,HIGH(623-1)
	brne ZEILE_SYNCHRONIMPULS_TRABANT_Z623_ERROR
	cpi ZL,LOW (623-1)
	brne ZEILE_SYNCHRONIMPULS_TRABANT_Z623_ERROR
rjmp BILDAUFBAU_FERTIG
;-------------------------------------------------------------------------------
ZEILE_SYNCHRONIMPULS_TRABANT_Z623_ERROR:
	;ERROR
	ldi temp,(ERROR_CODE_TV_D)
	rcall TV_ERROR_SPEICHERN_TEMP	; ERROR speichern
rjmp BILDAUFBAU_FERTIG
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Leere Zeile ausgeben 															
ZEILE_NULL:
	; SYNCHRONIMPULS						
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L	/ 0 Volt   / 4,7s		
	rcall WAIT_4_7us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	; 0,3 Volt 				
rjmp BILDAUFBAU_FERTIG
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Leere Zeile ausgeben	und  DATA-RESET (ZEIGER auf DATENFELD)					
ZEILE_NULL_UND_DATA_INITIALISIERUNG:
	; SYNCHRONIMPULS						
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L	/ 0 Volt   / 4,7s		
	rcall WAIT_4_7us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H	; 0,3 Volt 				
	; DATA-RESET							
	ldi ZL, LOW (adr_TV_BILDBEREICH)
	ldi ZH, HIGH(adr_TV_BILDBEREICH)
	STS(adr_TV_ZEIGER_DATA_L),ZL
	STS(adr_TV_ZEIGER_DATA_H),ZH
rjmp BILDAUFBAU_FERTIG
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Eine TV-ZEILE schreiben														
; 40-Bytes (40x8=320PIXEL)														
ZEILE_DATA_Z:
	; SYNCHRONIMPULS (0V)				
	cbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC L
	rcall WAIT_4_7us
	sbi (TV_SYNC_PORT),(TV_SYNC_PIN_NR)		; SYNC H
;-----------------------------------------										
; hintere SCHWARZschulter 														
; Sie muss mindestens 5,8s betragen, bevor Bilddaten gesendet werden knnen.	
; Die Zeitvorgabe wird aber erfllt, durch den taktintensiven TV-ZEILEN-CHECK !	
;	rcall wait_5_8us
	; BILD positionieren (linker RAND)	
	nop
	nop
	nop
	nop
	nop
;-----------------------------------------										
; TV-ZEILEN-CHECK, der TURBO-MODUS !											
; Eine TV-Zeile wird in 5 Bereiche unterteilt und nun untersuchen 				
; wir jeden einzelnen Bereich, ob Daten gesendet werden mssen.					
; Liegen keine Daten vor, dann wird der Interrupt so schnell wie 				
; mglich wieder verlassen														
; Wenn TV-Zeile keine DATEN enthlt,  nicht schreiben, Taktersparnis !			
	LDS ZL,(adr_TV_ZEIGER_DATA_L)	; ZEIGER-DATA laden		
	LDS ZH,(adr_TV_ZEIGER_DATA_H)
	clr temp2
	; BEREICH-1							
	clr temp1	; Clear
	;---------------
	LD temp,Z+	; 1 aus SRAM auslesen	
	or temp1,temp	; verknpfen		
	LD temp,Z+	; 2
	or temp1,temp
	LD temp,Z+	; 3
	or temp1,temp
	LD temp,Z+	; 4
	or temp1,temp
	LD temp,Z+	; 5
	or temp1,temp
	LD temp,Z+	; 6
	or temp1,temp
	LD temp,Z+	; 7
	or temp1,temp
	LD temp,Z+	; 8
	or temp1,temp
	;---------------
	tst temp1
	breq ZEILE_DATA_w1
	ldi temp2,1	;---->1
ZEILE_DATA_w1:
	; BEREICH-2							
	clr temp1	; Clear
	;---------------
	LD temp,Z+	; 9
	or temp1,temp
	LD temp,Z+	; 10
	or temp1,temp
	LD temp,Z+	; 11
	or temp1,temp
	LD temp,Z+	; 12
	or temp1,temp
	LD temp,Z+	; 13
	or temp1,temp
	LD temp,Z+	; 14
	or temp1,temp
	LD temp,Z+	; 15
	or temp1,temp
	LD temp,Z+	; 16
	or temp1,temp
	;---------------
	tst temp1
	breq ZEILE_DATA_w2
	ldi temp2,2	;---->2
ZEILE_DATA_w2:
	; BEREICH-3							
	clr temp1	; Clear
	;---------------
	LD temp,Z+	; 17
	or temp1,temp
	LD temp,Z+	; 18
	or temp1,temp
	LD temp,Z+	; 19
	or temp1,temp
	LD temp,Z+	; 20
	or temp1,temp
	LD temp,Z+	; 21
	or temp1,temp
	LD temp,Z+	; 22
	or temp1,temp
	LD temp,Z+	; 23
	or temp1,temp
	LD temp,Z+	; 24
	or temp1,temp
	;---------------
	tst temp1
	breq ZEILE_DATA_w3
	ldi temp2,3	;---->3
ZEILE_DATA_w3:
	; BEREICH-4							
	clr temp1	; Clear
	;---------------
	LD temp,Z+	; 25
	or temp1,temp
	LD temp,Z+	; 26
	or temp1,temp
	LD temp,Z+	; 27
	or temp1,temp
	LD temp,Z+	; 28
	or temp1,temp
	LD temp,Z+	; 29
	or temp1,temp
	LD temp,Z+	; 30
	or temp1,temp
	LD temp,Z+	; 31
	or temp1,temp
	LD temp,Z+	; 32
	or temp1,temp
	;---------------
	tst temp1
	breq ZEILE_DATA_w4
	ldi temp2,4	;---->4
ZEILE_DATA_w4:
	; BEREICH-5							
	clr temp1	; Clear
	;---------------
	LD temp,Z+	; 33
	or temp1,temp
	LD temp,Z+	; 34
	or temp1,temp
	LD temp,Z+	; 35
	or temp1,temp
	LD temp,Z+	; 36
	or temp1,temp
	LD temp,Z+	; 37
	or temp1,temp
	LD temp,Z+	; 38
	or temp1,temp
	LD temp,Z+	; 39
	or temp1,temp
	LD temp,Z+	; 40
	or temp1,temp
	;---------------
	tst temp1
	breq ZEILE_DATA_w5
	ldi temp2,5	;---->5
ZEILE_DATA_w5:
;-----------------------------------------										
	ldi ZL, LOW (ZEILE_DATA_Z_RUN_SPRUNGMARKE)
	ldi ZH, HIGH(ZEILE_DATA_Z_RUN_SPRUNGMARKE)
	add ZL,temp2
	adc ZH,NULL
	IJMP		; SPRUNG (Zeiger nach Z)
ZEILE_DATA_Z_RUN_SPRUNGMARKE:; Achtung jmp belegt zwei Worte, rjmp nur ein Wort
	rjmp ZEILE_DATA_Z_NO_DATA
	rjmp ZEILE_DATA_Z_RUN_1_8		; BEREICH-1								
	rjmp ZEILE_DATA_Z_RUN_1_16		; BEREICH-1+2							
	rjmp ZEILE_DATA_Z_RUN_1_24		; BEREICH-1+2+3							
	rjmp ZEILE_DATA_Z_RUN_1_32		; BEREICH-1+2+3+4						
	rjmp ZEILE_DATA_Z_RUN_1_40		; BEREICH-1+2+3+4+5						
	; ERROR		
	ldi temp,(ERROR_CODE_TV_B)
	rcall TV_ERROR_SPEICHERN_TEMP	; ERROR speichern
;-----------------------------------------										
; keine DATEN																	
ZEILE_DATA_Z_NO_DATA:
	; ZEIGER-DATA laden					
	LDS ZL,(adr_TV_ZEIGER_DATA_L)
	LDS ZH,(adr_TV_ZEIGER_DATA_H)
	adiw ZL,40		; (+ 40)
	STS(adr_TV_ZEIGER_DATA_L),ZL	; ZEIGER-DATA save		
	STS(adr_TV_ZEIGER_DATA_H),ZH
	rjmp BILDAUFBAU_FERTIG
;-----------------------------------------										
; TV-ZEILE schreiben (nur 8 BITES)												
ZEILE_DATA_Z_RUN_1_8:
	; ZEIGER-DATA laden					
	LDS ZL,(adr_TV_ZEIGER_DATA_L)
	LDS ZH,(adr_TV_ZEIGER_DATA_H)
	; jeweils ein DATENBYTE ausgeben	
	MACRO_TV_DATA_Z	; 1
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z	; 8
	; DUNKEL									
	nop
	cbi (TV_DATA_PORT),(TV_DATA_PIN_NR)		; DATA L
	adiw ZL,32		; (+ 32)
	STS(adr_TV_ZEIGER_DATA_L),ZL; ZEIGER-DATA save							
	STS(adr_TV_ZEIGER_DATA_H),ZH
rjmp BILDAUFBAU_FERTIG
;-----------------------------------------										
; TV-ZEILE schreiben (nur 16 BITES)												
ZEILE_DATA_Z_RUN_1_16:
	; ZEIGER-DATA laden					
	LDS ZL,(adr_TV_ZEIGER_DATA_L)
	LDS ZH,(adr_TV_ZEIGER_DATA_H)
	; jeweils ein DATENBYTE ausgeben	
	MACRO_TV_DATA_Z	; 1
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z	; 10
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z	; 16
	; DUNKEL									
	nop
	cbi (TV_DATA_PORT),(TV_DATA_PIN_NR)		; DATA L
	adiw ZL,24		; (+ 24)
	STS(adr_TV_ZEIGER_DATA_L),ZL; ZEIGER-DATA save							
	STS(adr_TV_ZEIGER_DATA_H),ZH
rjmp BILDAUFBAU_FERTIG
;-----------------------------------------										
; TV-ZEILE schreiben (nur 24 BITES)												
ZEILE_DATA_Z_RUN_1_24:
	; ZEIGER-DATA laden					
	LDS ZL,(adr_TV_ZEIGER_DATA_L)
	LDS ZH,(adr_TV_ZEIGER_DATA_H)
	; jeweils ein DATENBYTE ausgeben	
	MACRO_TV_DATA_Z	; 1
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z	; 10
	MACRO_TV_DATA_Z	
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z	; 20
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z	; 24
	; DUNKEL									
	nop
	cbi (TV_DATA_PORT),(TV_DATA_PIN_NR)		; DATA L
	adiw ZL,16		; (+ 16)
	STS(adr_TV_ZEIGER_DATA_L),ZL; ZEIGER-DATA save							
	STS(adr_TV_ZEIGER_DATA_H),ZH
rjmp BILDAUFBAU_FERTIG
;-----------------------------------------										
; TV-ZEILE schreiben (nur 32 BITES)												
ZEILE_DATA_Z_RUN_1_32:
	; ZEIGER-DATA laden					
	LDS ZL,(adr_TV_ZEIGER_DATA_L)
	LDS ZH,(adr_TV_ZEIGER_DATA_H)
	; jeweils ein DATENBYTE ausgeben	
	MACRO_TV_DATA_Z	; 1
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z	; 10
	MACRO_TV_DATA_Z	
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z	; 20
	MACRO_TV_DATA_Z	
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z	; 30
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z	; 32
	; DUNKEL									
	nop
	cbi (TV_DATA_PORT),(TV_DATA_PIN_NR)		; DATA L
	adiw ZL,8		; (+ 8)
	STS(adr_TV_ZEIGER_DATA_L),ZL; ZEIGER-DATA save							
	STS(adr_TV_ZEIGER_DATA_H),ZH
jmp BILDAUFBAU_FERTIG
;-----------------------------------------										
; TV-ZEILE komplett schreiben													
ZEILE_DATA_Z_RUN_1_40:
	; ZEIGER-DATA laden					
	LDS ZL,(adr_TV_ZEIGER_DATA_L)
	LDS ZH,(adr_TV_ZEIGER_DATA_H)
	; jeweils ein DATENBYTE ausgeben	
	MACRO_TV_DATA_Z	; 1
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z	; 10
	MACRO_TV_DATA_Z	
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z	; 20
	MACRO_TV_DATA_Z	
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z	; 30
	MACRO_TV_DATA_Z	
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z
	MACRO_TV_DATA_Z	; 40
	; DUNKEL									
	nop
	cbi (TV_DATA_PORT),(TV_DATA_PIN_NR)		; DATA L
	STS(adr_TV_ZEIGER_DATA_L),ZL; ZEIGER-DATA save							
	STS(adr_TV_ZEIGER_DATA_H),ZH
jmp BILDAUFBAU_FERTIG
; ##############################################################################
; ##############################################################################
; ##############################################################################

